Index: CKEditor/trunk/_source/plugins/link/dialogs/anchor.js
===================================================================
--- CKEditor/trunk/_source/plugins/link/dialogs/anchor.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/link/dialogs/anchor.js	(revision 6241)
@@ -39,5 +39,5 @@
 
 			// Set name.
-			element.removeAttribute( '_cke_saved_name' );
+			element.data( 'cke-saved-name', false );
 			element.setAttribute( 'name', name );
 
@@ -62,5 +62,5 @@
 			var selection = editor.getSelection();
 			var element = selection.getSelectedElement();
-			if ( element && element.getAttribute( '_cke_real_element_type' ) && element.getAttribute( '_cke_real_element_type' ) == 'anchor' )
+			if ( element && element.data( 'cke-real-element-type' ) && element.data( 'cke-real-element-type' ) == 'anchor' )
 			{
 				this.fakeObj = element;
Index: CKEditor/trunk/_source/plugins/link/dialogs/link.js
===================================================================
--- CKEditor/trunk/_source/plugins/link/dialogs/link.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/link/dialogs/link.js	(revision 6241)
@@ -76,4 +76,6 @@
 				element.hide();
 		}
+
+		dialog.layout();
 	};
 
@@ -95,5 +97,5 @@
 	var parseLink = function( editor, element )
 	{
-		var href = ( element  && ( element.getAttribute( '_cke_saved_href' ) || element.getAttribute( 'href' ) ) ) || '',
+		var href = ( element  && ( element.data( 'cke-saved-href' ) || element.getAttribute( 'href' ) ) ) || '',
 		 	javascriptMatch,
 			emailMatch,
@@ -185,5 +187,5 @@
 			if ( !target )
 			{
-				var onclick = element.getAttribute( '_cke_pa_onclick' ) || element.getAttribute( 'onclick' ),
+				var onclick = element.data( 'cke-pa-onclick' ) || element.getAttribute( 'onclick' ),
 					onclickMatch = onclick && onclick.match( popupRegex );
 				if ( onclickMatch )
@@ -243,5 +245,5 @@
 		{
 			var item = elements.getItem( i );
-			if ( item.getAttribute( '_cke_realelement' ) && item.getAttribute( '_cke_real_element_type' ) == 'anchor' )
+			if ( item.data( 'cke-realelement' ) && item.data( 'cke-real-element-type' ) == 'anchor' )
 				anchors.push( editor.restoreRealElement( item ) );
 		}
@@ -792,5 +794,5 @@
 					{
 						type : 'vbox',
-						width : 260,
+						width : '100%',
 						align : 'center',
 						padding : 2,
@@ -896,7 +898,7 @@
 											{
 												type :  'text',
-												widths : [ '30%', '70%' ],
+												widths : [ '50%', '50%' ],
 												labelLayout : 'horizontal',
-												label : linkLang.popupWidth,
+												label : commonLang.width,
 												id : 'width',
 												setup : setupPopupParams,
@@ -907,5 +909,5 @@
 												type :  'text',
 												labelLayout : 'horizontal',
-												widths : [ '55%', '45%' ],
+												widths : [ '50%', '50%' ],
 												label : linkLang.popupLeft,
 												id : 'left',
@@ -923,6 +925,6 @@
 												type :  'text',
 												labelLayout : 'horizontal',
-												widths : [ '30%', '70%' ],
-												label : linkLang.popupHeight,
+												widths : [ '50%', '50%' ],
+												label : commonLang.height,
 												id : 'height',
 												setup : setupPopupParams,
@@ -934,5 +936,5 @@
 												labelLayout : 'horizontal',
 												label : linkLang.popupTop,
-												widths : [ '55%', '45%' ],
+												widths : [ '50%', '50%' ],
 												id : 'top',
 												setup : setupPopupParams,
@@ -1146,6 +1148,6 @@
 				selection.selectElement( element );
 			else if ( ( element = selection.getSelectedElement() ) && element.is( 'img' )
-					&& element.getAttribute( '_cke_real_element_type' )
-					&& element.getAttribute( '_cke_real_element_type' ) == 'anchor' )
+					&& element.data( 'cke-real-element-type' )
+					&& element.data( 'cke-real-element-type' ) == 'anchor' )
 			{
 				this.fakeObj = element;
@@ -1174,10 +1176,10 @@
 					var protocol = ( data.url && data.url.protocol != undefined ) ? data.url.protocol : 'http://',
 						url = ( data.url && data.url.url ) || '';
-					attributes._cke_saved_href = ( url.indexOf( '/' ) === 0 ) ? url : protocol + url;
+					attributes[ 'data-cke-saved-href' ] = ( url.indexOf( '/' ) === 0 ) ? url : protocol + url;
 					break;
 				case 'anchor':
 					var name = ( data.anchor && data.anchor.name ),
 						id = ( data.anchor && data.anchor.id );
-					attributes._cke_saved_href = '#' + ( name || id || '' );
+					attributes[ 'data-cke-saved-href' ] = '#' + ( name || id || '' );
 					break;
 				case 'email':
@@ -1226,5 +1228,5 @@
 					}
 
-					attributes._cke_saved_href = linkHref.join( '' );
+					attributes[ 'data-cke-saved-href' ] = linkHref.join( '' );
 					break;
 			}
@@ -1254,5 +1256,5 @@
 
 					onclickList.push( featureList.join( ',' ), '\'); return false;' );
-					attributes[ '_cke_pa_onclick' ] = onclickList.join( '' );
+					attributes[ 'data-cke-pa-onclick' ] = onclickList.join( '' );
 
 					// Add the "target" attribute. (#5074)
@@ -1266,5 +1268,5 @@
 						removeAttributes.push( 'target' );
 
-					removeAttributes.push( '_cke_pa_onclick', 'onclick' );
+					removeAttributes.push( 'data-cke-pa-onclick', 'onclick' );
 				}
 			}
@@ -1305,5 +1307,5 @@
 					// Short mailto link text view (#5736).
 					var text = new CKEDITOR.dom.text( data.type == 'email' ?
-							data.email.address : attributes._cke_saved_href, editor.document );
+							data.email.address : attributes[ 'data-cke-saved-href' ], editor.document );
 					ranges[0].insertNode( text );
 					ranges[0].selectNodeContents( text );
@@ -1334,5 +1336,5 @@
 				// We're only editing an existing link, so just overwrite the attributes.
 				var element = this._.selectedElement,
-					href = element.getAttribute( '_cke_saved_href' ),
+					href = element.data( 'cke-saved-href' ),
 					textView = element.getHtml();
 
@@ -1361,5 +1363,5 @@
 					// Short mailto link text view (#5736).
 					element.setHtml( data.type == 'email' ?
-						data.email.address : attributes._cke_saved_href );
+						data.email.address : attributes[ 'data-cke-saved-href' ] );
 				}
 				// Make the element display as an anchor if a name has been set.
Index: CKEditor/trunk/_source/plugins/link/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/link/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/link/plugin.js	(revision 6241)
@@ -74,5 +74,5 @@
 					if ( element.is( 'a' ) )
 						evt.data.dialog =  ( element.getAttribute( 'name' ) && !element.getAttribute( 'href' ) ) ? 'anchor' : 'link';
-					else if ( element.is( 'img' ) && element.getAttribute( '_cke_real_element_type' ) == 'anchor' )
+					else if ( element.is( 'img' ) && element.data( 'cke-real-element-type' ) == 'anchor' )
 						evt.data.dialog = 'anchor';
 				}
@@ -117,5 +117,5 @@
 						return null;
 
-					var isAnchor = ( element.is( 'img' ) && element.getAttribute( '_cke_real_element_type' ) == 'anchor' );
+					var isAnchor = ( element.is( 'img' ) && element.data( 'cke-real-element-type' ) == 'anchor' );
 
 					if ( !isAnchor )
Index: CKEditor/trunk/_source/plugins/menu/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/menu/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/menu/plugin.js	(revision 6241)
@@ -54,4 +54,5 @@
 			this.editor = editor;
 			this.items = [];
+			this._.listeners = [];
 
 			this._.level = definition.level || 1;
@@ -72,4 +73,82 @@
 		_ :
 		{
+			onShow : function()
+			{
+				var selection = this.editor.getSelection();
+
+				// Selection will be unavailable after menu shows up
+				// in IE, lock it now.
+				if ( CKEDITOR.env.ie )
+					selection && selection.lock();
+
+				var element = selection && selection.getStartElement(),
+					listeners = this._.listeners,
+					includedItems = [];
+
+				this.removeAll();
+				// Call all listeners, filling the list of items to be displayed.
+				for ( var i = 0 ; i < listeners.length ; i++ )
+				{
+					var listenerItems = listeners[ i ]( element, selection );
+
+					if ( listenerItems )
+					{
+						for ( var itemName in listenerItems )
+						{
+							var item = this.editor.getMenuItem( itemName );
+
+							if ( item )
+							{
+								item.state = listenerItems[ itemName ];
+								this.add( item );
+							}
+						}
+					}
+				}
+			},
+
+			onClick : function( item )
+			{
+				this.hide();
+
+				if ( item.onClick )
+					item.onClick();
+				else if ( item.command )
+					this.editor.execCommand( item.command );
+			},
+
+			onEscape : function( keystroke )
+			{
+				var parent = this.parent;
+				// 1. If it's sub-menu, restore the last focused item
+				// of upper level menu.
+				// 2. In case of a top-menu, close it.
+				if ( parent )
+				{
+					parent._.panel.hideChild();
+					// Restore parent block item focus.
+					var parentBlock = parent._.panel._.panel._.currentBlock,
+						parentFocusIndex =  parentBlock._.focusIndex;
+					parentBlock._.markItem( parentFocusIndex );
+				}
+				else if ( keystroke == 27 )
+				{
+					this.hide();
+					this.editor.focus();
+				}
+				return false;
+			},
+
+			onHide : function()
+			{
+				if ( CKEDITOR.env.ie )
+				{
+					var selection = this.editor.getSelection();
+					selection && selection.unlock();
+				}
+
+				this.onHide && this.onHide();
+			},
+
 			showSubMenu : function( index )
 			{
@@ -99,7 +178,5 @@
 								   CKEDITOR.tools.extend( {}, this._.definition, { level : this._.level + 1 }, true ) );
 					menu.parent = this;
-					menu.onClick = CKEDITOR.tools.bind( this.onClick, this );
-					// Sub menu use their own scope for binding onEscape.
-					menu.onEscape = this.onEscape;
+					menu._.onClick = CKEDITOR.tools.bind( this._.onClick, this );
 				}
 
@@ -143,4 +220,15 @@
 			show : function( offsetParent, corner, offsetX, offsetY )
 			{
+				// Not for sub menu.
+				if ( !this.parent )
+				{
+					this._.onShow();
+					// Don't menu with zero items.
+					if ( ! this.items.length )
+						return;
+				}
+
+				corner = corner || ( this.editor.lang.dir == 'rtl' ? 2 : 1 );
+
 				var items = this.items,
 					editor = this.editor,
@@ -158,5 +246,5 @@
 					panel.onEscape = CKEDITOR.tools.bind( function( keystroke )
 					{
-						if ( this.onEscape && this.onEscape( keystroke ) === false )
+						if ( this._.onEscape( keystroke ) === false )
 							return false;
 					},
@@ -165,5 +253,5 @@
 					panel.onHide = CKEDITOR.tools.bind( function()
 					{
-						this.onHide && this.onHide();
+						this._.onHide && this._.onHide();
 					},
 					this );
@@ -214,5 +302,5 @@
 								this._.showSubMenu( index );
 							else
-								this.onClick && this.onClick( item );
+								this._.onClick( item );
 						},
 						this );
@@ -248,4 +336,6 @@
 				element.setHtml( output.join( '' ) );
 
+				CKEDITOR.ui.fire( 'ready', this );
+
 				// Show the panel.
 				if ( this.parent )
@@ -257,6 +347,12 @@
 			},
 
+			addListener : function( listenerFn )
+			{
+				this._.listeners.push( listenerFn );
+			},
+
 			hide : function()
 			{
+				this._.onHide && this._.onHide();
 				this._.panel && this._.panel.hide();
 			}
@@ -278,40 +374,38 @@
 			});
 	}
-})();
-
-CKEDITOR.menuItem = CKEDITOR.tools.createClass(
-{
-	$ : function( editor, name, definition )
+	CKEDITOR.menuItem = CKEDITOR.tools.createClass(
 	{
-		CKEDITOR.tools.extend( this, definition,
-			// Defaults
-			{
-				order : 0,
-				className : 'cke_button_' + name
-			});
-
-		// Transform the group name into its order number.
-		this.group = editor._.menuGroups[ this.group ];
-
-		this.editor = editor;
-		this.name = name;
-	},
-
-	proto :
-	{
-		render : function( menu, index, output )
+		$ : function( editor, name, definition )
 		{
-			var id = menu.id + String( index ),
-				state = ( typeof this.state == 'undefined' ) ? CKEDITOR.TRISTATE_OFF : this.state;
-
-			var classes = ' cke_' + (
-				state == CKEDITOR.TRISTATE_ON ? 'on' :
-				state == CKEDITOR.TRISTATE_DISABLED ? 'disabled' :
-				'off' );
-
-			var htmlLabel = this.label;
-
-			if ( this.className )
-				classes += ' ' + this.className;
+			CKEDITOR.tools.extend( this, definition,
+				// Defaults
+				{
+					order : 0,
+					className : 'cke_button_' + name
+				});
+
+			// Transform the group name into its order number.
+			this.group = editor._.menuGroups[ this.group ];
+
+			this.editor = editor;
+			this.name = name;
+		},
+
+		proto :
+		{
+			render : function( menu, index, output )
+			{
+				var id = menu.id + String( index ),
+					state = ( typeof this.state == 'undefined' ) ? CKEDITOR.TRISTATE_OFF : this.state;
+
+				var classes = ' cke_' + (
+					state == CKEDITOR.TRISTATE_ON ? 'on' :
+					state == CKEDITOR.TRISTATE_DISABLED ? 'disabled' :
+					'off' );
+
+				var htmlLabel = this.label;
+
+				if ( this.className )
+					classes += ' ' + this.className;
 
 			var hasSubMenu = this.getItems;
@@ -330,23 +424,23 @@
 					( state == CKEDITOR.TRISTATE_ON ? 'aria-pressed="true"' : '' ) );
 
-			// Some browsers don't cancel key events in the keydown but in the
-			// keypress.
-			// TODO: Check if really needed for Gecko+Mac.
-			if ( CKEDITOR.env.opera || ( CKEDITOR.env.gecko && CKEDITOR.env.mac ) )
-			{
+				// Some browsers don't cancel key events in the keydown but in the
+				// keypress.
+				// TODO: Check if really needed for Gecko+Mac.
+				if ( CKEDITOR.env.opera || ( CKEDITOR.env.gecko && CKEDITOR.env.mac ) )
+				{
+					output.push(
+						' onkeypress="return false;"' );
+				}
+
+				// With Firefox, we need to force the button to redraw, otherwise it
+				// will remain in the focus state.
+				if ( CKEDITOR.env.gecko )
+				{
+					output.push(
+						' onblur="this.style.cssText = this.style.cssText;"' );
+				}
+
+				var offset = ( this.iconOffset || 0 ) * -16;
 				output.push(
-					' onkeypress="return false;"' );
-			}
-
-			// With Firefox, we need to force the button to redraw, otherwise it
-			// will remain in the focus state.
-			if ( CKEDITOR.env.gecko )
-			{
-				output.push(
-					' onblur="this.style.cssText = this.style.cssText;"' );
-			}
-
-			var offset = ( this.iconOffset || 0 ) * -16;
-			output.push(
 //					' onkeydown="return CKEDITOR.ui.button._.keydown(', index, ', event);"' +
 					' onmouseover="CKEDITOR.tools.callFunction(', menu._.itemOverFn, ',', index, ');"' +
@@ -372,12 +466,15 @@
 			}
 
-			output.push(
-							htmlLabel,
-						'</span>' +
-				'</a>' +
-				'</span>' );
+				output.push(
+								htmlLabel,
+							'</span>' +
+					'</a>' +
+					'</span>' );
 		}
-	}
-});
+		}
+	});
+
+})();
+
 
 /**
Index: CKEditor/trunk/_source/plugins/menubutton/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/menubutton/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/menubutton/plugin.js	(revision 6241)
@@ -6,5 +6,5 @@
 CKEDITOR.plugins.add( 'menubutton',
 {
-	requires : [ 'button', 'contextmenu' ],
+	requires : [ 'button', 'menu' ],
 	beforeInit : function( editor )
 	{
@@ -36,6 +36,12 @@
 		if ( !menu )
 		{
-			menu = _.menu = new CKEDITOR.plugins.contextMenu( editor );
-			menu.definition.panel.attributes[ 'aria-label' ] = editor.lang.common.options;
+			menu = _.menu = new CKEDITOR.menu( editor,
+			{
+				panel:
+				{
+					className : editor.skinClass + ' cke_contextmenu',
+					attributes : { 'aria-label' : editor.lang.common.options }
+				}
+			});
 
 			menu.onHide = CKEDITOR.tools.bind( function()
Index: CKEditor/trunk/_source/plugins/pagebreak/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/pagebreak/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/pagebreak/plugin.js	(revision 6241)
@@ -89,6 +89,5 @@
 		// Creates the fake image used for this element.
 		breakObject = editor.createFakeElement( breakObject, 'cke_pagebreak', 'div' );
-		breakObject.setAttribute( 'alt', label );
-		breakObject.setAttribute( 'aria-label', label );
+		breakObject.setAttributes( { alt : label, 'aria-label' : label, title : label } );
 
 		var ranges = editor.getSelection().getRanges( true );
Index: CKEditor/trunk/_source/plugins/panel/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/panel/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/panel/plugin.js	(revision 6241)
@@ -137,10 +137,4 @@
 					langCode = parentDiv.getParent().getAttribute( 'lang' ),
 					doc = iframe.getFrameDocument();
-				// Initialize the IFRAME document body.
-				doc.$.open();
-
-				// Support for custom document.domain in IE.
-				if ( CKEDITOR.env.isCustomDomain() )
-					doc.$.domain = document.domain;
 
 				var onLoad = CKEDITOR.tools.addFunction( CKEDITOR.tools.bind( function( ev )
@@ -151,5 +145,5 @@
 					}, this ) );
 
-				doc.$.write(
+				var data =
 					'<!DOCTYPE html>' +
 					'<html dir="' + dir + '" class="' + className + '_container" lang="' + langCode + '">' +
@@ -163,6 +157,7 @@
 						// available. (#3031)
 						CKEDITOR.tools.buildStyleHtml( this.css ) +
-					'<\/html>' );
-				doc.$.close();
+					'<\/html>';
+
+				doc.write( data );
 
 				var win = doc.getWindow();
@@ -195,4 +190,5 @@
 				holder = doc.getBody();
 				holder.unselectable();
+				CKEDITOR.env.air && CKEDITOR.tools.callFunction( onLoad );
 			}
 			else
Index: CKEditor/trunk/_source/plugins/pastetext/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/pastetext/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/pastetext/plugin.js	(revision 6241)
@@ -38,18 +38,4 @@
 	};
 
-	function doInsertText( doc, text )
-	{
-		// Native text insertion.
-		if ( CKEDITOR.env.ie )
-		{
-			var selection = doc.selection;
-			if ( selection.type == 'Control' )
-				selection.clear();
-			selection.createRange().pasteHTML( text );
-		}
-		else
-			doc.execCommand( 'inserthtml', false, text );
-	}
-
 	// Register the plugin.
 	CKEDITOR.plugins.add( 'pastetext',
@@ -85,50 +71,4 @@
 	});
 
-	function doEnter( editor, mode, times, forceMode )
-	{
-		while ( times-- )
-		{
-			CKEDITOR.plugins.enterkey[ mode == CKEDITOR.ENTER_BR ? 'enterBr' : 'enterBlock' ]
-					( editor, mode, null, forceMode );
-		}
-	}
-
-	CKEDITOR.editor.prototype.insertText = function( text )
-	{
-		this.focus();
-		this.fire( 'saveSnapshot' );
-
-		var mode = this.getSelection().getStartElement().hasAscendant( 'pre', true ) ? CKEDITOR.ENTER_BR : this.config.enterMode,
-			isEnterBrMode = mode == CKEDITOR.ENTER_BR,
-			doc = this.document.$,
-			self = this,
-			line;
-
-		text = CKEDITOR.tools.htmlEncode( text.replace( /\r\n|\r/g, '\n' ) );
-
-		var startIndex = 0;
-		text.replace( /\n+/g, function( match, lastIndex )
-		 {
-			line = text.substring( startIndex, lastIndex );
-			startIndex = lastIndex + match.length;
-			line.length && doInsertText( doc, line );
-
-			var lineBreakNums = match.length,
-				// Duo consequence line-break as a enter block.
-				enterBlockTimes = isEnterBrMode ? 0 : Math.floor( lineBreakNums / 2 ),
-				// Per link-break as a enter br.
-				enterBrTimes = isEnterBrMode ? lineBreakNums : lineBreakNums % 2;
-
-			// Line-breaks are converted to editor enter key strokes.
-			doEnter( self, mode, enterBlockTimes );
-			doEnter( self, CKEDITOR.ENTER_BR, enterBrTimes, isEnterBrMode ? false : true );
-		 });
-
-		// Insert the last text line of text.
-		line = text.substring( startIndex, text.length );
-		line.length && doInsertText( doc, line );
-
-		this.fire( 'saveSnapshot' );
-	};
 })();
 
Index: CKEditor/trunk/_source/plugins/placeholder/dialogs/placeholder.js
===================================================================
--- CKEditor/trunk/_source/plugins/placeholder/dialogs/placeholder.js	(revision 6241)
+++ CKEditor/trunk/_source/plugins/placeholder/dialogs/placeholder.js	(revision 6241)
@@ -0,0 +1,78 @@
+﻿/*
+ * Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+ * For licensing, see LICENSE.html or http://ckeditor.com/license
+ */
+
+(function()
+{
+	function placeholderDialog( editor, isEdit )
+	{
+
+		var lang = editor.lang.placeholder,
+			generalLabel = editor.lang.common.generalTab;
+		return {
+			title : lang.title,
+			minWidth : 300,
+			minHeight : 80,
+			contents :
+			[
+				{
+					id : 'info',
+					label : generalLabel,
+					title : generalLabel,
+					elements :
+					[
+						{
+							id : 'text',
+							type : 'text',
+							style : 'width: 100%;',
+							label : lang.text,
+							'default' : '',
+							required : true,
+							validate : CKEDITOR.dialog.validate.notEmpty( lang.textMissing ),
+							setup : function( element )
+							{
+								if ( isEdit )
+									this.setValue( element.getText().slice( 2, -2 ) );
+							},
+							commit : function( element )
+							{
+								var text = '[[' + this.getValue() + ']]';
+								// The placeholder must be recreated.
+								CKEDITOR.plugins.placeholder.createPlaceholder( editor, element, text );
+							}
+						}
+					]
+				}
+			],
+			onShow : function()
+			{
+				if ( isEdit )
+				{
+					var range = editor.getSelection().getRanges()[0];
+					range.shrink( CKEDITOR.SHRINK_TEXT );
+					var node = range.startContainer;
+					while( node && !( node.type == CKEDITOR.NODE_ELEMENT && node.data( 'cke-placeholder' ) ) )
+						node = node.getParent();
+					this._element = node;
+				}
+
+				this.setupContent( this._element );
+			},
+			onOk : function()
+			{
+				this.commitContent( this._element );
+				delete this._element;
+			}
+		};
+	}
+
+	CKEDITOR.dialog.add( 'createplaceholder', function( editor )
+		{
+			return placeholderDialog( editor );
+		});
+	CKEDITOR.dialog.add( 'editplaceholder', function( editor )
+		{
+			return placeholderDialog( editor, 1 );
+		});
+} )();
Index: CKEditor/trunk/_source/plugins/placeholder/lang/en.js
===================================================================
--- CKEditor/trunk/_source/plugins/placeholder/lang/en.js	(revision 6241)
+++ CKEditor/trunk/_source/plugins/placeholder/lang/en.js	(revision 6241)
@@ -0,0 +1,16 @@
+﻿/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.plugins.setLang( 'placeholder', 'en',
+{
+	placeholder :
+	{
+		title		: 'Placeholder Properties',
+		toolbar		: 'Create Placeholder',
+		text		: 'Placeholder Text',
+		edit		: 'Edit Placeholder',
+		textMissing	: 'The placeholder must contain text.'
+	}
+});
Index: CKEditor/trunk/_source/plugins/placeholder/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/placeholder/plugin.js	(revision 6241)
+++ CKEditor/trunk/_source/plugins/placeholder/plugin.js	(revision 6241)
@@ -0,0 +1,160 @@
+﻿/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+/**
+ * @fileOverview The "placeholder" plugin.
+ *
+ */
+
+(function()
+{
+	var placeholderReplaceRegex = /\[\[[^\]]+\]\]/g;
+	CKEDITOR.plugins.add( 'placeholder',
+	{
+		requires : [ 'dialog' ],
+		lang : [ 'en' ],
+		init : function( editor )
+		{
+			var lang = editor.lang.placeholder;
+
+			editor.addCommand( 'createplaceholder', new CKEDITOR.dialogCommand( 'createplaceholder' ) );
+			editor.addCommand( 'editplaceholder', new CKEDITOR.dialogCommand( 'editplaceholder' ) );
+
+			editor.ui.addButton( 'CreatePlaceholder',
+			{
+				label : lang.toolbar,
+				command :'createplaceholder',
+				icon : this.path + 'placeholder.gif'
+			});
+
+			if ( editor.addMenuItems )
+			{
+				editor.addMenuGroup( 'placeholder', 20 );
+				editor.addMenuItems(
+					{
+						editplaceholder :
+						{
+							label : lang.edit,
+							command : 'editplaceholder',
+							group : 'placeholder',
+							order : 1,
+							icon : this.path + 'placeholder.gif'
+						}
+					} );
+
+				if ( editor.contextMenu )
+				{
+					editor.contextMenu.addListener( function( element, selection )
+						{
+							if ( !element || !element.data( 'cke-placeholder' ) )
+								return null;
+
+							return { editplaceholder : CKEDITOR.TRISTATE_OFF };
+						} );
+				}
+			}
+
+			editor.on( 'doubleclick', function( evt )
+				{
+					var element = evt.data.element;
+					if ( element.data( 'cke-placeholder' ) )
+						evt.data.dialog = 'editplaceholder';
+				});
+
+			editor.addCss(
+				'.cke_placeholder' +
+				'{' +
+					'background-color: #ffff00;' +
+					( CKEDITOR.env.gecko ? 'cursor: default;' : '' ) +
+				'}'
+			);
+
+			editor.on( 'contentDom', function()
+				{
+					editor.document.getBody().on( 'resizestart', function( evt )
+						{
+							if ( editor.getSelection().getSelectedElement().data( 'cke-placeholder' ) )
+								evt.data.preventDefault();
+						});
+				});
+
+			CKEDITOR.dialog.add( 'createplaceholder', this.path + 'dialogs/placeholder.js' );
+			CKEDITOR.dialog.add( 'editplaceholder', this.path + 'dialogs/placeholder.js' );
+		},
+		afterInit : function( editor )
+		{
+			var dataProcessor = editor.dataProcessor,
+				dataFilter = dataProcessor && dataProcessor.dataFilter,
+				htmlFilter = dataProcessor && dataProcessor.htmlFilter;
+
+			if ( dataFilter )
+			{
+				dataFilter.addRules(
+				{
+					text : function( text )
+					{
+						return text.replace( placeholderReplaceRegex, function( match )
+							{
+								return CKEDITOR.plugins.placeholder.createPlaceholder( editor, null, match, 1 );
+							});
+					}
+				});
+			}
+
+			if ( htmlFilter )
+			{
+				htmlFilter.addRules(
+				{
+					elements :
+					{
+						'span' : function( element )
+						{
+							if ( element.attributes && element.attributes[ 'data-cke-placeholder' ] )
+								delete element.name;
+						}
+					}
+				});
+			}
+		}
+	});
+})();
+
+CKEDITOR.plugins.placeholder =
+{
+	createPlaceholder : function( editor, oldElement, text, isGet )
+	{
+		var element = new CKEDITOR.dom.element( 'span', editor.document );
+		element.setAttributes(
+			{
+				contentEditable		: 'false',
+				'data-cke-placeholder'	: 1,
+				'class'			: 'cke_placeholder'
+			}
+		);
+
+		text && element.setText( text );
+
+		if ( isGet )
+			return element.getOuterHtml();
+
+		if ( oldElement )
+		{
+			if ( CKEDITOR.env.ie )
+			{
+				element.insertAfter( oldElement );
+				// Some time is required for IE before the element is removed.
+				setTimeout( function()
+					{
+						oldElement.remove();
+						element.focus();
+					}, 10 );
+			}
+			else
+				element.replace( oldElement );
+		}
+		else
+			editor.insertElement( element );
+	}
+};
Index: CKEditor/trunk/_source/plugins/removeformat/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/removeformat/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/removeformat/plugin.js	(revision 6241)
@@ -99,5 +99,5 @@
 						// This node must not be a fake element.
 						if ( !( currentNode.getName() == 'img'
-							&& currentNode.getAttribute( '_cke_realelement' ) )
+							&& currentNode.data( 'cke-realelement' ) )
 							&& filter( editor, currentNode ) )
 						{
Index: CKEditor/trunk/_source/plugins/richcombo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 6241)
@@ -107,6 +107,5 @@
 					}
 
-					!_.committed && this.commit();
-
+					this.commit();
 					var value = this.getValue();
 					if ( value )
@@ -198,5 +197,5 @@
 							'<span id="' + id + '_text" class="cke_text cke_inline_label">' + this.label + '</span>' +
 						'</span>' +
-						'<span class=cke_openbutton>' + ( CKEDITOR.env.hc ? '<span>&#9660;</span>' : '' ) + '</span>' +	// BLACK DOWN-POINTING TRIANGLE
+						'<span class=cke_openbutton>' + ( CKEDITOR.env.hc ? '<span>&#9660;</span>' : CKEDITOR.env.air ?  '&nbsp;' : '' ) + '</span>' +	// BLACK DOWN-POINTING TRIANGLE
 					'</a>' +
 				'</span>' +
@@ -346,5 +345,10 @@
 		commit : function()
 		{
-			this._.list.commit();
+			if ( !this._.committed )
+			{
+				this._.list.commit();
+				this._.committed = 1;
+				CKEDITOR.ui.fire( 'ready', this );
+			}
 			this._.committed = 1;
 		},
Index: CKEditor/trunk/_source/plugins/scayt/dialogs/options.js
===================================================================
--- CKEditor/trunk/_source/plugins/scayt/dialogs/options.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/scayt/dialogs/options.js	(revision 6241)
@@ -201,5 +201,5 @@
 	tags = CKEDITOR.plugins.scayt.uiTabs;
 
-	for ( var i in tags )
+	for ( i in tags )
 	{
 		if ( tags[ i ] == 1 )
@@ -290,5 +290,5 @@
 		if ( tags[1] ==1 )
 		{
-			for ( var i in lang_list.rtl )
+			for ( i in lang_list.rtl )
 				langList[ langList.length ] = createOption( i, lang_list.ltr );
 
Index: CKEditor/trunk/_source/plugins/scayt/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/scayt/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/scayt/plugin.js	(revision 6241)
@@ -359,6 +359,6 @@
 		loadEngine : function( editor )
 		{
-			// SCAYT doesn't work with Firefox2, Opera.
-			if ( CKEDITOR.env.gecko && CKEDITOR.env.version < 10900 || CKEDITOR.env.opera )
+			// SCAYT doesn't work with Firefox2, Opera and AIR.
+			if ( CKEDITOR.env.gecko && CKEDITOR.env.version < 10900 || CKEDITOR.env.opera || CKEDITOR.env.air )
 				return editor.fire( 'showScaytState' );
 
@@ -759,5 +759,5 @@
 					editor.removeListener( 'showScaytState', showInitialState );
 
-					if ( !CKEDITOR.env.opera )
+					if ( !CKEDITOR.env.opera && !CKEDITOR.env.air )
 						command.setState( plugin.isScaytEnabled( editor ) ? CKEDITOR.TRISTATE_ON : CKEDITOR.TRISTATE_OFF );
 					else
@@ -767,5 +767,5 @@
 			editor.on( 'showScaytState', showInitialState );
 
-			if ( CKEDITOR.env.opera )
+			if ( CKEDITOR.env.opera || CKEDITOR.env.air )
 			{
 				editor.on( 'instanceReady', function()
Index: CKEditor/trunk/_source/plugins/showblocks/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/showblocks/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/showblocks/plugin.js	(revision 6241)
@@ -148,5 +148,6 @@
 /**
  * Whether to automaticaly enable the "show block" command when the editor
- * loads.
+ * loads. (StartupShowBlocks in FCKeditor)
+ * @name CKEDITOR.config.startupOutlineBlocks
  * @type Boolean
  * @default false
Index: CKEditor/trunk/_source/plugins/showborders/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/showborders/plugin.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/showborders/plugin.js	(revision 6241)
@@ -195,4 +195,6 @@
 /**
  * Whether to automatically enable the "show borders" command when the editor loads.
+ * (ShowBorders in FCKeditor)
+ * @name CKEDITOR.config.startupShowBorders
  * @type Boolean
  * @default true
Index: CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js
===================================================================
--- CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js	(revision 6232)
+++ CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js	(revision 6241)
@@ -35,5 +35,5 @@
 				{
 					src : src,
-					_cke_saved_src : src,
+					'data-cke-saved-src' : src,
 					title : title,
 					alt : title,
